<?php

//*********************************************
//          ASSOTLD - www.assotld.it          *
//           Invio automatico E-LAR           *
//                  Ver. 1.1                  *
//                                            *
// Script per il caricamento da parte         *
// dell'utente finale delle e-lar in formato  *
// pdf e loro invio automatico al Registro.   *
// Viene inoltre inviata all'indirizzo del    *
// mittente una copia della e-lar inviata     *
//                                            *
// Lo script verifica la correttezza          *
// sintattica del dominio, la sua             *
// disponibilit tramite query a das.nic.it,  *
// la dimensione dell'allegato e la relativa  *
// estensione.                                *
//                                            *
//                                            *
// E' sufficiente valorizzare i parametri:    *
// $mnt_password: Password del maintainer     *
// $mnt_name: Sigla del maintainer            *
// $mittente: indirizzo e-mail da far         *
//            figurare nell'e-mail inviata al *
//            registro                        *
//                                            *
//                                            *
//*********************************************
//  Per informazioni e suggerimenti:          *
//  Cassinari Alessandro (alex@insystem.it)   *
//*********************************************


//*********************************************
//  Inizio area configurabile                 *
//*********************************************

$mnt_password = "123456";
$mnt_name = "XXXXXX-MNT";
$mittente = "mnt@assotld.it";

//*********************************************
//  Fine area configurabile                   *
//  Nella parte finale del file  presente il *
//  codice html per personalizzare il form di *
//  richiesta dati                            *
//*********************************************


ini_set("sendmail_from", $mittente );
$domainname = $_POST['domainname'];
$destinatario = "elar@elar.nic.it";
$oggetto = "Invio LAR elettronica";


$allegato = $_FILES['lar']['tmp_name'];
$allegato_type = $_FILES['lar']['type'];
$allegato_name = $_FILES['lar']['name'];







if ($_POST['sendlar'] == "1")
{


  if (eregi("^[([:alnum:])]+[-([:alnum:])]{1,61}[([:alnum:])]+(\.[([:alnum:])]+[-([:alnum:])]*[([:alnum:])]+)*\.it$",$domainname))

  {



    $whoisp =  fsockopen("das.nic.it", 4343, $errno, $errstr, 30);
    $domainavailable = false;
    if (!$whoisp) {
      echo "errore durante la query a das.nic.it:4343";
    } else {
       fputs($whoisp, $domainname . "\r\n");
       while (!feof($whoisp)) {
         $whois_output .= fread($whoisp,128);
         if(strpos($whois_output, 'Status: AVAILABLE') !== false )
         {
           $domainavailable = true;
         }

       }

       fclose ($whoisp);
    }

    if ($domainavailable)
    {

      if (is_uploaded_file($allegato))
      {
        if (strtolower(get_ext($allegato_name)) == ".pdf")
        {
          $dimensionefile = (int) $_FILES['lar']['size'];
          if ($dimensionefile.to < 512000)
          {
            $headers = "From: " . $mittente;
            $headers .= "\nReturn-Path: " . $mittente;
            $headers .= "\nReply-To: " . $mittente;
            $headers .= "\nX-Sent-From: ASSOTLD E-LAR dispatcher (www.assotld.it)";
            $headers .= "\nX-Originator-IP: " . $_SERVER['REMOTE_ADDR'];
            $msg = "";
            $file = fopen($allegato,'rb');
            $data = fread($file, filesize($allegato));
            fclose($file);
            $data = chunk_split(base64_encode($data));
            $semi_rand = md5(time());
            $mime_boundary = "==Multipart_Boundary_x{$semi_rand}x";
            $headers .= "\nMIME-Version: 1.0\n";
            $headers .= "Content-Type: multipart/mixed;\n";
            $headers .= " boundary=\"{$mime_boundary}\"";
            $msg .= "This is a multi-part message in MIME format.\n\n";
            $msg .= "--{$mime_boundary}\n";
            $msg .= "Content-Type: text/plain; charset=\"iso-8859-1\"\n";
            $msg .= "Content-Transfer-Encoding: 7bit\n\n";
            $msg .= "password: " . $mnt_password . "\n";
            $msg .= "mntner: " . $mnt_name . "\n";
            $msg .= "domain: " . $domainname . "\n";
            $msg .= "\n\n";
            $msg .= "--{$mime_boundary}\n";
            $msg .= "Content-Disposition: attachment;\n";
            $msg .= " filename=\"elar.pdf\"\n";
            $msg .= "Content-Transfer-Encoding: base64\n\n";
            $msg .= $data . "\n\n";
            $msg .= "--{$mime_boundary}--\n";

            if (mail($destinatario, $oggetto, $msg, $headers))
            {
              echo "<p>E-LAR trasmessa con successo!</p>";
              mail($mittente, "Copia della E-LAR inviata automaticamente al Registro", $msg, $headers);

            }else{
              echo "<p>Errore durante il trasferimento della E-LAR!</p>";
            }

          }
          else
          {
            echo "<p>La ELAR non pu superare i 500kB!</p>";
          }
        }
        else
        {
          echo "<p>La ELAR deve avere estensione .PDF</p>";
        }
      }
      else
      {
        echo "<p>ELAR non caricata!</p>";
      }
    }
    else
    {
      echo "<p>Dominio non disponibile</p>";
    }
  }
  else
  {
      echo "<p>Il dominio deve essere '.it' e deve essere conforme a quanto indicato nel Regolamento disponibile all'indirizzo http://www.nic.it/domini/index.html</p>";
  }



}


function get_ext($name) 
{ 
     $ext = strrchr($name, '.'); 
     if($ext !== false) 
     { 
         $name = substr($name, strlen($name)-strlen($ext)); 
     } 
     return $name; 
} 
?>



<form action="elar.php" method="POST" enctype="multipart/form-data">
<input type="hidden" name="sendlar" value="1">
<table border="0">
<tr>
  <td colspan="2"><h2>Invio automatico E-LAR</h2></td>
</tr>
<tr>
  <td>Nome dominio:</td>
  <td><input type="text" name="domainname" value="" /></td>
</tr>
<tr>
  <td>E-LAR:</td>
  <td><input type="file" name="lar" /> (max 500kB e con estensione ".pdf")</td>
</tr>
<tr>
  <td colspan="2"><input type="submit" value="Invia" /></td>
</tr>
</table>
</form>

